<?php
/** 
*	iCagenda
*-----------------------------------------------------------------------------------------
*	@package     	com_icagenda
*   @version		$version 1.2.6 JoomliC $
*   @copyright		Copyright (C) 2012 JoomliC. Tous droits rÃÂ©servÃÂ©s / All rights reserved.
*   	Displays <a href="http://www.gnu.org/licenses/gpl-2.0.html">GNU/GPL License</a>
*	@license		GNU General Public License version 2 or later; see LICENSE.txt
*		Displays <a href="http://www.joomlic.com">www.joomlic.com</a>
*	@link			http://www.joomlic.com
*	@author			JoomliC <info@joomlic.com>
*	Updated			06/10/2012
*-----------------------------------------------------------------------------------------
*/


// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.modelitem');

class iCModelItem extends JModelItem 
{
	/**
	 * @var msg
	 */
	protected $msg;
	protected $filters;
	protected $options;
	protected $itObj;
	protected $where;

	/**
	 * Model Builder
	 */
	protected function startiCModel() 
	{
        $this->filters = array();
        $this->options = array();
        $this->items = array();
        $this->itObj= new stdClass;
   }

	/**
	 * Table importation
	 */
	public function getTable($type = 'icagenda', $prefix = 'icagendaTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	/**
	 * Get all data
	 */
/*
public function getItems()
{
        // Get a storage key.
        $store = $this->_getStoreId();
 
        // Try to load the data from internal storage.
        if (!empty($this->_cache[$store])) {
                return $this->_cache[$store];
        }
 
        // Load the list items.
        $query  = $this->_getListQuery();
        $items  = $this->_getList((string) $query, $this->getState('list.start'), $this->getState('list.limit'));
 
        // Check for a database error.
        if ($this->_db->getErrorNum()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
        }
 
        // Add the items to the internal cache.
        $this->_cache[$store] = $items;
 
        return $this->_cache[$store];
        
}
*/

	protected function getItems ($structure)
	{
		// renvoie les éléments
		if(isset($this->items)) $this->items=$this->getDBitems();
		 
		foreach ($structure as $k=>$v)
		{
			$this->itObj->$k=$this->$k($v);
		}
		return $this->itObj;
	}

	/**
	 * Add the filters to be used in queries
	 */
	protected function addFilter($name, $value)
	{
		$this->filters[$name]=$value;
	}

	/**
	 * Add the options you use to obtain the various data in the right setting
	 */
	protected function addOption($name, $value)
	{
		$this->options[$name]=$value;
	}


	/**
	 * Fetch data from DB
	 */
	protected function getDBitems()
	{
		// Preparing connection to db
		$db	= $this->getDbo();

		// Preparing the query
		$query = $db->getQuery(true);

		// Selectable items
		$query->select('e.id, e.title, e.alias, e.params, e.catid, e.image, e.file, e.dates, e.time, e.desc, e.next, e.address, e.city, e.phone, e.email, e.place as place_name, e.coordinate as coordinate');
		$query->select(' l.desc as location_desc');
		$query->select(' c.title as cat_title, c.color as cat_color, c.desc as cat_desc, c.alias as cat_alias');
		//$query->select(' r.id as regisId');

		// join
		$query->from('`#__icagenda_events` AS e');
		$query->leftJoin('`#__icagenda_category` AS c ON c.id = e.catid');
		$query->leftJoin('`#__icagenda_events` AS l ON l.id = e.place');
		//$query->leftJoin('`#__icagenda_location` AS l ON l.id = e.location');
		//$query->leftJoin('`#__icagenda_registration` AS r ON r.eventid = e.id');
		
		// Where (filters)
		$filters=$this->filters;
		$where='e.state ='.$filters['state'];
		unset($filters['state']);
		foreach($filters as $k=>$v){
			
			// normal cases
			if ($k!='key' && $k!='next' && $k!='e.catid' && $k!='id'){
				$where.=' AND '.$k.' LIKE "%'.$v.'%"';
			}
			
			// in case of search
			if ($k=='key'){
				$keys=explode(' ', $v);
				foreach ($keys as $ke){
					$where.=' AND (e.title LIKE \'%'.$ke.'%\' OR ';
					$where.=' e.desc LIKE \'%'.$ke.'%\' OR ';
					$where.=' e.address LIKE \'%'.$ke.'%\' OR ';
					$where.=' e.place LIKE \'%'.$ke.'%\' OR ';
					$where.=' c.title LIKE \'%'.$ke.'%\')';
				}
			}
			
			// in the case of time
			if ($k=='next'){
				if($v==1) $where.=' AND e.next >= (CURDATE())';
				if($v==2) $where.=' AND e.next < (CURDATE())';
			}
			
			// in the case of category
			if ($k=='e.catid'){
				$where.=' AND '.$k.'='.$v;
				$ccat=$v;
			}
			
			// in case of id
			if ($k=='id'){
				$where.=' AND e.id='.$v;
			}
		}
		$this->where=$where;
		$query->where($where);
		// order and limit the query
				
		$orderdate = $this->options['orderby'];
		// in the case of order
				if ($orderdate==0){
					$query->order('e.next');
				}
				if ($orderdate==1){
					$query->order('e.next DESC');
				}
				if ($orderdate==2){
					$query->order('e.next ASC');
				}

		
		
		$getpage=JRequest::getVar('page');		
		
		
		if (!$getpage){
			$start='0';
		}else{
			$start = $this->options['number']*($getpage-1);
		}
		$query.=' LIMIT '.$start.', '.$this->options['number'];
		$db->setQuery($query);
		return $db->loadObjectList();
	}

	// *** NOW BEGINS A SERIES OF FUNCTIONS DEDICATED TO OBTAIN ALL NECESSARY VALUES TO FILL THE OBJECT *** //

	// *** CONTAINER *** //
	protected function container ($atr){
		$contDef=new stdClass;
		foreach ($atr as $k=>$v){
			$contDef->$k=$this->$k();
		}
		return $contDef;
	}
	protected function template ()
	{
		return $this->options['template'];
	}

	protected function navigator ()
	{
		// declare the controls
		$ctrlNext=NULL;
		$ctrlBack=NULL;
		$getpage=JRequest::getVar('page');		

		// check if there are other events after those selected
		$db	= $this->getDbo();
		$query = $db->getQuery(true);
		$query->select('count(e.id) AS max')->from('#__icagenda_events AS e');
				
		$filters=$this->filters;
		$where='e.state ='.$filters['state'];
		unset($filters['state']);
		foreach($filters as $k=>$v){
			
			// normal cases
			if ($k!='key' && $k!='next' && $k!='e.catid' && $k!='e.id'){
				$where.=' AND '.$k.' LIKE "%'.$v.'%"';
			}
			
			// in the case of time
			if ($k=='next'){
				if($v==1) $where.=' AND e.next >= (CURDATE())';
				if($v==2) $where.=' AND e.next < (CURDATE())';
			}
			
			// in the case of category
			if ($k=='e.catid'){
				$where.=' AND '.$k.'='.$v;
			}
		}
		if (!$getpage){
			$start='0';
		}else{
			$start = $this->options['number']*($getpage-1);
		}
		$query.=' LIMIT '.$start.', '.($this->options['number']+1);
		$db->setQuery($query);
		$max=$db->loadObject()->max;
		if ($max > $this->options['number'])$ctrlNext=1;

		// first check whether there are elements of those selected
		if($getpage && $getpage>1)$ctrlBack=1;

		$nbevents='';$total='';$timetitle='';$timetext='';$timetext1='';$noevt='';
		$db	= $this->getDbo();
		$query = $db->getQuery(true);


		// Adding Filter per Category in Navigation - Bug Fixed 1.2.6 released
		$selcat=$this->options['mcatid'];
		if ($selcat==0){
			$selcat='e.catid';
		}
		else {
			$selcat=$selcat;
		}
		
		if ($v==0){
			$query->select('count(id) AS nbevents')->from('#__icagenda_events AS e')->where("(e.state > 0) AND (e.catid=$selcat)");
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$total=$nbevents;
			$timetitle=''.JText::_( 'COM_ICAGENDA_ALL_TITLE' ).'';
			$timetext=''.JText::_( 'COM_ICAGENDA_ALL_TEXT' ).'';
			$timetext1=''.JText::_( 'COM_ICAGENDA_ALL_TEXT_ONE' ).'';
			$noevt=''.JText::_( 'COM_ICAGENDA_ALL_NO_EVENT_TEXT' ).'';

		}
		if ($v==1){
			$query->select('count(id) AS nbevents')->from('#__icagenda_events AS e')->where( "(e.next >= (CURDATE())) AND (e.state > 0) AND (e.catid=$selcat)" );
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$total=$nbevents;
			$timetitle=''.JText::_( 'COM_ICAGENDA_FUTURE_TITLE' ).'';
			$timetext=''.JText::_( 'COM_ICAGENDA_FUTURE_TEXT' ).'';
			$timetext1=''.JText::_( 'COM_ICAGENDA_FUTURE_TEXT_ONE' ).'';
			$noevt=''.JText::_( 'COM_ICAGENDA_FUTURE_NO_EVENT_TEXT' ).'';

		}
		if ($v==2){
			$query->select('count(id) AS nbevents')->from('#__icagenda_events AS e')->where( "(e.next < (CURDATE())) AND (e.state > 0) AND (e.catid=$selcat)" );
			$db->setQuery($query);
			$nbevents=$db->loadObject()->nbevents;
			$total=$nbevents;
			$timetitle=''.JText::_( 'COM_ICAGENDA_PAST_TITLE' ).'';
			$timetext=''.JText::_( 'COM_ICAGENDA_PAST_TEXT' ).'';
			$timetext1=''.JText::_( 'COM_ICAGENDA_PAST_TEXT_ONE' ).'';
			$noevt=''.JText::_( 'COM_ICAGENDA_PAST_NO_EVENT_TEXT' ).'';

		}
		

$report='';$report2='';$report3='';$report4='';
		if ($nbevents==1) {
			$report.= '<h2> '.$timetitle.' <br/></h2> <small> '.JText::_( 'COM_ICAGENDA_ONE_EVENT_TEXT' ).' '.$total.' '.$timetext1.' </small>';
		}
		if ($nbevents==0) {
			$report.= ' <h2> '.$timetitle.' <br/></h2><small> '.$noevt.' </small>';
		}
		if ($nbevents>1) {
			$report.= ' <h2> '.$timetitle.' <br/></h2><small> '.JText::_( 'COM_ICAGENDA_EVENTS_TEXT' ).' '.$total.' '.$timetext.' </small>';
		}
		$num=$this->options['number'];
		
		if ($num == NULL) {
			$pages= 1;
		return JError::raiseError( 404, "iCagenda view page not found" );

		}
		else {
			$pages=ceil($total/$num);
		}
			
			$pon=$getpage;
		if (JRequest::getVar('page')==NULL){
			$pon=1;
		}
		if ($pages<=1) {
			$report2.= '<br/><br/>';
		}
		
		else {
			$report2.= ' <small> - '.JText::_( 'COM_ICAGENDA_EVENTS_PAGE' ).' '.$pon.' / '.$pages.'</small><br/><br/>';
		}
		
		$report3.= ' <small> '.JText::_( 'COM_ICAGENDA_EVENTS_PAGE' ).' '.$pon.' / '.$pages.'</small><br/><br/>';

		$report4.= '<br> '.JText::_( 'COM_ICAGENDA_SEARCH_RESULTS' ).' &nbsp; ';
		
		
		// create the navigator

		$allcat=$this->filters['mcatid'];
		
		if ($k==0  &&  $k!='key') {
			$nav='<div class="navigator">'.$report.' '.$report2;
		}
		elseif ($k=='e.catid'  &&  $k!='key') {
			$nav='<div class="navigator">'.$report3;
		}

		else {
			$nav='<div class="navigator">'.$report4;
		}
		
		
		
// idea by L.V. : insert text with forward/back arrows.
		$arrowtext = $this->options['arrowtext'];
		// in the case of text next/prev
				if ($arrowtext==1){
					$textnext=JText::_( 'JNEXT' );
					$textback=JText::_( 'JPREV' );
				}

		$parentnav = $this->options['Itemid'];

		$mainframe = JFactory::getApplication();
		$isSef = $mainframe->getCfg( 'sef' ); 
		
		if ($isSef == '1') {
			$urlback=JRoute::_(JURI::current().'?');
			$urlnext=JRoute::_(JURI::current().'?');
		}
		if ($isSef == '0') {
			$urlback='index.php?option=com_icagenda&view=list&Itemid='.(int)$parentnav.'&';
			$urlnext='index.php?option=com_icagenda&view=list&Itemid='.(int)$parentnav.'&';
		}
		
		if ($pages>=2) {
			
		if ($ctrlBack!=NULL){
			if ($getpage && $getpage<$pages) {
				$pageBack=$getpage-1;
				$pageNext=$getpage+1;
				$nav.='<a class="icagenda_back" href="'.$urlback.'page='.$pageBack.'">&#9668 '.$textback.'</a>';
				$nav.='<a class="icagenda_next" href="'.$urlnext.'page='.$pageNext.'">'.$textnext.' &#9658</a>';
			}
			else {
				$pageBack=$getpage-1;
				$nav.='<a class="icagenda_back" href="'.$urlback.'page='.$pageBack.'">&#9668 '.$textback.'</a>';
			}
		}
		if ($ctrlNext!=NULL){
			if(!$getpage){
				$pageNext=2;
			}
			else{
				$pageNext=$getpage+1;
				$pageBack=$getpage-1;
			}
			$nav.='<a class="icagenda_next" href="'.$urlnext.'page='.$pageNext.'">'.$textnext.' &#9658</a>';
		}
		
		}
		
		$nav.='</div>';
		return $nav;
	}


	// *** ITEMS *** //


	protected function items ($atr){
		$atr=$atr['item'];
		$items=$this->items;
		$itDef=new stdClass;
		if ($this->items == NULL) {

		}
		else {
			foreach($items as $i){
			$i=$this->ctrlNext($i);
			$it=new stdClass;
			$id=$i->id;
			foreach($atr as $k=>$v){
				if($i->$k!=NULL){
					$it->$k=$i->$k;
				}else{
					if(method_exists($this, $k)){$it->$k=$this->$k($i);}
				}
			}
			$itDef->$id=$it;
		}
		return $itDef;
		}
		
	}

	protected function url ($i){
		$lien = $this->options['Itemid'];
		$eventnumber = $i->id;

		$urlevent = JRoute::_('index.php?option=com_icagenda&view=list&layout=event&Itemid='.(int)$lien.'&id='.(int)$eventnumber);
//		$items=array(
//				'id' => $eventnumber,
//				'Itemid' => $lien,
//				'url'=> $urlevent,
//				'title' => $i->title,
//				'image' => $i->image,
//				'dates' => $i->dataini,
//				'next' => date('Y-m-d', $next),
//				'time' => $i->time,
//				'address' => $i->address,
//				'place' => $i->place,
//				'cat_title' => $i->cat_title,
//				'cat_color' => $i->cat_color,
//			);
		$url=$urlevent;
		return $url;

	}

	protected function titleLink ($i){
		$title=$i->title;
		$url=$this->url($i);
		return '<a href="'.$url.'">'.$title.'</a>';
	}

	protected function descShort ($i){
		$limit=$this->options['limit'];
		$text=strip_tags($i->desc);
//		$text=preg_replace('/<img[^>]*>/Ui', '', $i->desc);
//		$text=str_replace('<br>', '', $text);
//		$text=str_replace('<p></p>', '', $text);
//		$text=str_replace('<div></div>', '', $text);
		if(strlen($text)>$limit){
			$stringa_tagliata=substr($text, 0,$limit);
			$last_space=strrpos($stringa_tagliata," ");
			$stringa_ok=substr($stringa_tagliata, 0,$last_space);
			$text=$stringa_ok." ";
			$url=$this->url($i);
			$text=$text.'<a href="'.$url.'" class="more">[&#46;&#46;&#46;]</a>';
		}else{
			$text=$text;
		}
		return $text;
	}

	protected function imageTag ($i){
		return '<img src="'.$i->image.'"/>';
	}

	protected function fileTag ($i){
		return '<a class="xDownload" href="'.$i->file.'">'.JText::_( 'COM_ICAGENDA_EVENT_DOWNLOAD' ).'</a>';
	}

	protected function nextMkt ($i){
		return $this->mkt($i->next);
	}

	protected function nextDate ($i){
		$toDay=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$toDay=mktime(0,0,0,$m,$day,$y);
		$testDate = $this->mkt($i->next);
		if ($testDate == $toDay) {
			$nextDate = '<b>'.$this->formatDate($this->mkt($i->next)).'</b>';
		}
		else {
			$nextDate = $this->formatDate($this->mkt($i->next));
		}
			return $nextDate;
	}

	protected function dateText ($i)
	{
		$dates=unserialize($i->dates);
		$toDay=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$toDay=mktime(0,0,0,$m,$day,$y);
		$testDate = $this->mkt($i->next);
		$totDates = count($dates);
		if (($testDate > $toDay) AND ($totDates > 1)) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE_FUTUR' ).'';
		}
		if (($testDate > $toDay) AND ($totDates <= 1)) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE' ).'';
		}
		if (($testDate < $toDay) AND ($totDates > 1)) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE_PAST' ).'';
		}
		if (($testDate < $toDay) AND ($totDates <= 1)) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE' ).'';
		}
		if ($testDate == $toDay) {
			$dateText = ''.JText::_( 'COM_ICAGENDA_EVENT_DATE_TODAY' ).'';
		}
			return $dateText;
	}



	protected function day ($i){
		return date('d', $this->mkt($i->next));
	}

	protected function month ($i){
		return date('m', $this->mkt($i->next));
	}

	protected function year ($i){
		return date('Y', $this->mkt($i->next));
	}

	protected function yearShort ($i){
		return date('y', $this->mkt($i->next));
	}

	protected function datelist ($i){
		return unserialize($i->dates);
	}

	protected function datelistMkt ($i){
		$days=unserialize($i->dates);
		foreach ($days as $k=>$d){
			$days[$k]=$this->mkt($d);
		}
		return $days;
	}



	protected function datelistUl ($i){
		$days=unserialize($i->dates);
		$totDates = count($days);
		$daysUl='<ul class="xDates">';
		$fdjl=''.JText::_( 'COM_ICAGENDA_FORMAT_DATE_3' ).'';
		foreach ($days as $k=>$a){
			$fd=$this->formatDate($this->mkt($a), $fdjl);
   			$daysUl.='<li>'.$fd.'</li>';
		}
		$daysUl.='</ul>';
		if ($totDates > '1') {
		return $daysUl;
		}
	}



	protected function formatDate ($d, $for=NULL){
		if($for==NULL)$for=$this->options['format'];
		$exformat = explode ('-', $for);
		$format='';
		foreach($exformat as $k=>$val){
			switch($val){
				// day
				case 'd': $val='%d'; break;
				case 'D': $val='%a'; break;
				case 'j': $val='%e'; break;
				case 'l': $val='%A'; break;
				case 'N': $val='%u'; break;
				case 'w': $val='%w'; break;
				case 'z': $val='%j'; break;

				// week
				case 'W': $val='%W'; break;

				// month
				case 'F': $val='%B'; break;
				case 'm': $val='%m'; break;
				case 'M': $val='%b'; break;
				case 'n': $val='%m'; break;

				// year
				case 'Y': $val='%Y'; break;
				case 'y': $val='%g'; break;

				default: $val=''; break;		
			}
			if($k!=0)$format.=' '.$val;
			if($k==0)$format.=$val;
		}
		$lang = JFactory::getLanguage();
		$locale = $lang->getlocale() ;
		setlocale( LC_TIME, $locale[0] ) ;

		return strftime($format, $d);
	}
	protected function monthTxt ($i){
		return $this->formatDate($this->mkt($i->next), 'F');
	}

	protected function monthShort ($i){
		$mois=date('d-M-Y', $this->mkt($i->next));
		$lang = JFactory::getLanguage();
		$locale = $lang->getlocale() ;
		setlocale( LC_TIME, $locale[0] ) ;

 		$dateList = $mois;

		$l_day = strftime("%d", strtotime("$dateList")); 
		$l_monthShort = strftime("%b", strtotime("$dateList")); 
		$l_year = strftime("%Y", strtotime("$dateList"));
		$mois = $l_monthShort;
		return $mois;
	}

	protected function monthNum ($i){
		return $this->formatDate($this->mkt($i->next), 'm');
	}


	protected function lat ($i){
		$ex=explode(', ', $i->coordinate);
		return $ex[0];
	}

	protected function lng ($i){
		$ex=explode(', ', $i->coordinate);
		return $ex[1];
	}


	protected function map ($i){
		return '<script>jQuery(document).ready(function() { initialize('.$this->lat($i).', '.$this->lng($i).', '.$i->id.'); });</script><div class="icagenda_map" id="map_canvas'.$i->id.'" style="width:'.$this->options['m_width'].'; height:'.$this->options['m_height'].'"></div>';
	}



	protected function share ($i){
		$float = $this->options['atfloat'];
		$icon = $this->options['aticon'];
		$iconaddthis='';
		if ($float==0) {
			$floataddthis='default';
			$posfloat='right';
		}
		if ($float==1) {
			$floataddthis='floating';
			$posfloat='left';
		}
		if ($float==2) {
			$floataddthis='floating';
			$posfloat='right';
		}
		if ($icon==1) {
			$iconaddthis='16x16';
		}
		if ($icon==2) {
			$iconaddthis='32x32';
		}
		$text='<!-- AddThis Button BEGIN -->';
		$text.='<div class="addthis_toolbox addthis_'.$floataddthis.'_style addthis_'.$iconaddthis.'_style" style="'.$posfloat.':50px;top:40%;">';
		$text.='<a class="addthis_button_preferred_1"></a>';
		$text.='<a class="addthis_button_preferred_2"></a>';
		$text.='<a class="addthis_button_preferred_3"></a>';
		$text.='<a class="addthis_button_preferred_4"></a>';
		$text.='<a class="addthis_button_compact"></a>';
		$text.='<a class="addthis_counter addthis_bubble_style"></a>';
		$text.='</div>';
		$text.='<script type="text/javascript">var addthis_config = {"data_track_addressbar":true};</script>';

if ($this->options['addthis']) {
		$text.='<script type="text/javascript" src="http://s7.addthis.com/js/250/addthis_widget.js#pubid='.$this->options['addthis'].'"></script>';
}
else {
		$text.='<script type="text/javascript" src="http://s7.addthis.com/js/250/addthis_widget.js#pubid=ra-5024db5322322e8b"></script>';
}
		$text.='<!-- AddThis Button END -->';
		return $text;
	}



	protected function gcalendarUrl ($i){
		$ora=$i->time;
		if($ora==0)$ora='00.00';
		$text=$i->title.' ('.$i->cat_title.')';
		$details=$this->descShort($i);
		$place=$i->place.', '.$i->address;
		$link=$this->url($i);

		$date= JRequest::getVar('date');

		$dates=str_replace('-', '', $date).'T'.str_replace('.', '', $ora).'00/'.str_replace('-', '', $date).'T'.str_replace('.', '', $ora).'00';
		$href="http://www.google.com/calendar/event?action=TEMPLATE
			&text=".urlencode($text)."
			&dates=".$dates."
			&place=".urlencode($place)."
			&details=".urlencode($details)."
			&sprop=sito web:".urlencode($link);
		
		return $href;
	}

	protected function gcalendarLink ($i){
		return '<a href="'.$this->gcalendarUrl($i).'">Gcalendar</a>';
	}

	protected function regUrl ($i){
		$lien = $this->options['Itemid'];
		$eventnumber = $i->id;
		return JROUTE::_('index.php?option=com_icagenda&view=list&layout=registration&Itemid='.(int)$lien.'&id='.(int)$eventnumber);
	}

	protected function reg ($i){
		//return '<a class="regis_button" href="'.$this->regUrl($i).'">'.JText::_( 'ICAGENDA_REGISTRATION' ).'</a>';
		return '<a class="regis_button" href="'.$this->regUrl($i).'"><img src="media/com_icagenda/images/btn-regis.png" /></a>';
	}

	protected function registered ($i){

		// Preparing connection to db
		$db	= $this->getDbo();
		// Preparing the query
		$query = $db->getQuery(true);
		$query->select('COUNT(r.id) AS registered')->from('#__icagenda_registration AS r')->where('r.eventId='.$i->id);
		$db->setQuery($query);
		$items = $db->loadObjectList();
//      return $items[0]->registered;
		return $items[0];
	}


	/** FUNCTION TO CHECK IF NEXT MOVE **/
	protected function ctrlNext ($i){
		$toDay=time();
		$nextMkt=$this->mkt($i->next);
		$exora=explode(':', $i->time);
//		$h=date(h);
//		$m=date(i);
		$next= JRequest::getVar('next');
		if ($next>$toDay){
			$ctrl=0;
		}elseif($next==$toDay){
//			if($exora[0]>$h){
//				$ctrl=0;
//			}elseif($exora[1]>$m){
//				$ctrl=0;
//			}else{
//				$ctrl=1;
//			}
$ctrl=0;
		}else{
			$ctrl=1;
		}

		if($ctrl==0){
			return $i;
		}else{
			$days=unserialize($i->dates);
			foreach($days as $d){
				$dMkt=$this->mkt($d);
// si date passÂ + date aujourd'hui
				if ($dMkt<$toDay){
					$i->next=$d;
					return $i;
				}
//si date passÂ + date future
				else{
//					$i->next=$d;
					return $i;
				}
			}
			$this->writeNext($i);
			return $i;
		}

	}



	/** WRITING ON THE REGISTRATION OF A USER DB **/
	public function registration ($array){

		$data =new stdClass();
		$data->id = null;
		if(isset($array['userid'])) $data->userid = $array['userid'];
		if(isset($array['name'])) $data->name = $array['name'];
		if(isset($array['email'])) $data->email = $array['email'];
		if(isset($array['phone'])) $data->phone = $array['phone'];
		if(isset($array['date'])) $data->date = date('Y-m-d', $array['date']);
		if(isset($array['people'])) $data->people = $array['people'];
		if(isset($array['event'])) $data->eventid = $array['event'];
		$data->checked_out_time = date('Y-m-d H:i:s');

		$db = JFactory::getDBO();
		$db->insertObject( '#__icagenda_registration', $data, id );




		$content = 'alert( \''.JText::_( 'COM_ICAGENDA_REGISTRATION_TY' ).' '.$data->name.', '.JText::_( 'COM_ICAGENDA_REGISTRATION' ).'\' )';
		$doc =& JFactory::getDocument();
		$doc->addScriptDeclaration( $content );


	}



	// *** ESSENTIAL FUNCTIONS *** //
	private function mkt($data)
	{
		$data=str_replace(' ', '-', $data);
		$data=str_replace(':', '-', $data);
		$ex_data=explode('-', $data);
		$ris=mktime('0', '0', '0', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		return strftime($ris);
	}

	private function writeNext($i){
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);
		
		$query->update('#__icagenda_events')
			->set("`next`='".$next."'");
		$query->where('`id`='.$i->id);
		$db->setQuery($query);
		$db->query($query);
	}

}
?>